/**
 * @file mofron-comp-frame-center/index.js
 * @author simpart
 */
require('mofron-comp-frame');
require('mofron-layout-hrzcenter');
require('mofron-layout-vrtcenter');

mofron.comp.frame.Center = class extends mofron.comp.Frame {
    
    constructor (phei, wid) {
        try {
            super();
            this.name('Center');

            if (null !== phei) {
                this.prmOpt(
                    ('number' === typeof wid) ? {param : [phei, wid]} : phei
                );
            }
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    initDomConts (prm) {
        try {
            this.vdom().addChild(
                new mofron.Dom('div', this)
            );
            
            if (null !== prm) {
                this.frame().size(new mofron.Param(prm[0], prm[1]));
            }
            
            
            this.addChild(this.wrap());
            this.wrap().addChild(this.frame());
            this.height(this.height());
            
            this.target(this.frame().target());
            
            mofron.func.addResizeWin(
                function(frm) {
                    try {
                        frm.wrap().style({
                            width : window.innerWidth + 'px'
                        });
                    } catch (e) {
                        console.error(e.stack);
                        throw e;
                    }
                },
                this
            );
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    size (hei, wid) {
        try {
            this.vdom();
            var ret = super.size(hei, wid);
            if (undefined === hei) {
                return ret;
            } else {
                this.vrtCenter().height(hei);
                this.hrzCenter().width(wid);
            }
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    wrap (wp) {
        try {
            if (undefined === wp) {
                /* getter */
                if (undefined === this.m_wrap) {
                    this.wrap(new mofron.Component());
                }
                return this.m_wrap;
            }
            /* setter */
            if (false === mofron.func.isInclude(wp, 'Component')) {
                throw new Error('invalid parameter');
            }
            wp.name(['Frame', 'Center']);
            wp.layout([this.hrzCenter(), this.vrtCenter()]);
            this.m_wrap = wp;
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    frame (frm) {
        try {
            if (undefined === frm) {
                /* getter */
                if (undefined === this.m_frame) {
                    this.frame(
                        new mofron.comp.Frame({
                            name : 'Center'
                        })
                    );
                }
                return this.m_frame;
            }
            /* setter */
            if (false === mofron.func.isInclude(frm, 'Frame')) {
                throw new Error('invalid parameter');
            }
            this.m_frame = frm;
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    hrzCenter (lo) {
        try {
            if (undefined === lo) {
                /* getter */
                if (undefined === this.m_hrzcenter) {
                    this.hrzCenter(
                        new mofron.layout.HrzCenter({
                            width : this.frame().size()[1]
                        })
                    );
                }
                return this.m_hrzcenter;
            }
            /* setter */
            if (false === mofron.func.isInclude(lo,'HrzCenter')) {
                throw new Error('invalid parameter');
            }
            this.m_hrzcenter = lo;
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    vrtCenter (lo) {
        try {
            if (undefined === lo) {
                /* getter */
                if (undefined === this.m_vrtcenter) {
                    this.vrtCenter(
                        new mofron.layout.VrtCenter({
                            height : this.frame().size()[0]
                        })
                    );
                }
                return this.m_vrtcenter;
            }
            /* setter */
            if (false === mofron.func.isInclude(lo,'VrtCenter')) {
                throw new Error('invalid parameter');
            }
            this.m_vrtcenter = lo;
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    height (hei) {
        try {
            if (undefined === hei) {
                /* getter */
                if (null === this.wrap().style('height')) {
                    this.height(window.innerHeight);
                }
                return mofron.func.getLength(this.wrap().style('height'));
            }
            if ('number' !== typeof hei) {
                throw new Error('invalid parameter');
            }
            this.wrap().style({height : hei + 'px'});
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
}
mofron.comp.frame.center = {};
module.exports = mofron.comp.frame.Center;
